/*********************************************
 *  GPS Monitor
 *  GPS Data to LCD
 *  PIC16F18313
 ********************************************/
#include "mcc_generated_files/mcc.h"
#include "lcd_lib2.h"
#include <string.h>

// ϐ`
char rcv, Index, rData[80];
char Head[] = "$GPGGA";
char hour[3];
int16_t  time;
char Line1[] = "Time = xx:xx:xx";
char Line2[] = "N xx.xx E xxx.xx";
/******* C֐ ************************/
void main(void)
{
    SYSTEM_Initialize();
    Index = 0;
    // LCD
    lcd_init();             // LCD
    lcd_clear();            // LCDS
    /****** C[v ******************/
    while (1)
    {
        /**** GPSMobt@64oCg ***********/
        do {
            rcv = EUSART_Read();                    // 1M
            rData[Index++] = rcv;                   // obt@Ɋi[
        }while(rcv != 0x0A);                        // s܂ŌJԂ
        Index = 0;                                  // CfbNXZbg
        if(memcmp(rData, Head, 6) == 0){            // wb_`FbN
            LED_Toggle();                           // ڈ            
            /****** GPGGA̎Mi1bƁj ******/        
            memcpy(hour, rData+7, 2);               // ԕo
            time = atoi(hour);                      // Ԃ𐔒l
            //@̕␳@+9ԁ@24-24
            time = time + 9;                        // {9
            if(time >=24)                           // 24̏ꍇ
                time -= 24;                         // -24
            Line1[7] = (char)(time / 10) + '0';     // Ԃ𕶎ŃRs[
            Line1[8] = (char)(time % 10) + '0';
            memcpy(Line1+10, rData+9, 2);           // Rs[
            memcpy(Line1+13, rData+11, 2);          // bRs[
            lcd_cmd(0x80);                          // 1sڎw
            lcd_str(Line1);                         // \
            //@ܓxAox̕\
            memcpy(Line2+2, rData+18, 2);           // ܓx
            memcpy(Line2+5, rData+20, 2);           // ܓx
            memcpy(Line2+10, rData+30, 3);          // ox
            memcpy(Line2+14, rData+33, 2);          // ox
            lcd_cmd(0xC0);                          // 2sڎw
            lcd_str(Line2);                         // ܓxox\
        }
    }
}
